//
DefineConstant[
Rc  =   0.000050     // 0.001524      // nose radius [m] 
Rout=   2 * Rc       // outer boundary radius 
Phi =   7 * Pi / 180 // cone half angle
Psi =  97 * Pi / 180 // 
Ph2 =  30 * Pi / 180 //
Lx  =   30 * Rc       // length of cone
Ly  =   100 * Rc

Nx1 =  96
Nx2 =  480 // 11520 // 2880 
Ny  =  64 // 120
h   =   0            ];
//
xc = 0;
yc = 0;
//
// Points on circular arc
//
Point(1)  = {xc , yc, 0, h};                                                                 // O : Origin
Point(2)  = {xc + Rc * Cos( Pi  ), yc, 0, h};                                                // A : Cone nose
Point(3)  = {xc + Rc * Cos( Psi ), Rc * Sin( Psi ), 0, h};                                   // B : Point at junction of circular nose and tangent surface
Circle(1) = { 2, 1, 3 };
//
// Point on the cone surface
//
Point(4)  = {xc + Lx, yc + Rc * Sin( Psi ) + ( Lx + Rc * Sin( Phi ) ) * Tan ( Phi ), 0, h};  // D : Point at junction of circular nose and tangent surface
//
Line(2)   = {3, 4};
//
// Domain definition
//
Point(5)  = {xc + Rout * Cos( Pi  ), yc, 0, h};
Point(6)  = {xc + Rout * Cos( Ph2 + Pi / 2 ), Rout * Sin( Ph2 + Pi/2 ), 0, h};
LxOut     =  Lx - Rout * Cos (Ph2 + Pi/2 );
Point(7)  = {xc + Lx, Rout * Cos (Ph2) + LxOut * Tan( Ph2), 0, h};
//+
Circle(3) = {5, 1, 6};
//+
Line(4) = {6, 7};
Line(5) = {4, 7};
Line(6) = {2, 5};
//
Line(7) = {6, 3};
//+
Transfinite Line{1,3}     = Nx1 Using Progression 1;
Transfinite Line{2,4}     = Nx2 Using Progression 1;
Transfinite Line{-5,-6,7} = Ny  Using Progression 1;
//+
//+
Line Loop(1) = {3, 7, -1, 6};
Surface(1) = {1};
Line Loop(2) = {7, 2, 5, -4};
Surface(2) = {2};
//
Transfinite Surface "*";
Recombine Surface "*";
//
Rotate {{1,0,0},{-1,0,0},2.5*Pi/180.0}
{
Surface{1,2};
}
new_entities[] = Extrude {{1,0,0},{-1,0,0},-5*Pi/180.0}
{
Surface{1,2};
Layers{1};
Recombine;
};
//+
Physical Surface("wedge0") = {1, 2};
Physical Surface("wedge1") = {24, 46};
Physical Surface("inflow") = {15,45};
Physical Surface("cone") = {37, 22};
Physical Surface("outflow") = {41};
//+
Physical Volume("field") = {1, 2};
